// PortPage.cpp : implementation file
//

#include "stdafx.h"
#include "Serial758UI.h"
#include "PortPage.h"
#include "PortSheet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPortPage property page

IMPLEMENT_DYNCREATE(CPortPage, CPropertyPage)

CPortPage::CPortPage() : CPropertyPage(CPortPage::IDD)
{
	//{{AFX_DATA_INIT(CPortPage)
	//}}AFX_DATA_INIT
}

CPortPage::CPortPage(int PortNo) : CPropertyPage(CPortPage::IDD)
{
	m_nPortNo=PortNo-1;
	
}


CPortPage::~CPortPage()
{
}

void CPortPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPortPage)
	DDX_Control(pDX, IDC_IR, m_checkIR);
	DDX_Control(pDX, IDC_TXTRIG, m_comboTxTrig);
	DDX_Control(pDX, IDC_RXTRIG, m_comboRxTrig);
	DDX_Control(pDX, IDC_RTSHYS, m_comboRTSHys);
	DDX_Control(pDX, IDC_DTRHYS, m_comboDTRHys);
	DDX_Control(pDX, IDC_PORTOPEN, m_checkPortOpen);
	DDX_Control(pDX, IDC_TFIFO, m_checkTxFifo);
	DDX_Control(pDX, IDC_RXFIFO, m_checkRxFifo);
	DDX_Control(pDX, IDC_FLOWCNTL, m_comboFlowCtrl);
	DDX_Control(pDX, IDC_COMBASE, m_comboComBase);
	DDX_Control(pDX, IDC_CRS485, m_check485);
	DDX_Control(pDX, IDC_CRTS, m_checkRTS);
	DDX_Control(pDX, IDC_CDTR, m_checkDTR);
	DDX_Control(pDX, IDC_STOPBIT, m_comboStopBit);
	DDX_Control(pDX, IDC_PARITY, m_comboParity);
	DDX_Control(pDX, IDC_DATALEN, m_comboDataLength);
	DDX_Control(pDX, IDC_BAUD, m_comboBaud);
	//}}AFX_DATA_MAP


}


BEGIN_MESSAGE_MAP(CPortPage, CPropertyPage)
	//{{AFX_MSG_MAP(CPortPage)
		ON_CBN_SELCHANGE(IDC_COMBASE, OnSelchangeCombase)
	ON_BN_CLICKED(IDC_CDTR, OnDTREnabled)
	ON_BN_CLICKED(IDC_CRTS, OnRTSEnabled)
	ON_BN_CLICKED(IDC_RXFIFO, OnRxFifoEnabled)
	ON_BN_CLICKED(IDC_TFIFO, OnTxFifoEnabled)
	ON_CBN_DROPDOWN(IDC_STOPBIT, OnDropdownStopbit)
	ON_CBN_SELCHANGE(IDC_DATALEN, OnSelchangeDatalen)
	ON_BN_CLICKED(IDC_CRS485, OnCrs485)
	ON_BN_CLICKED(IDC_IR, OnIr)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPortPage message handlers

BOOL CPortPage::OnInitDialog() 
{
	//here the values of the dialog control variables are updated in the respective 
	//windows before the dialog pops up

	CPropertyPage::OnInitDialog();

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	//for databits 6,7,8 the stop bits are 1 or 2  and not 1.5 but for 5 databits the stop bits
	//to be selected are 1 or 1.5 and not 2.
	CString str1="1";
	CString str15="1.5";
	CString str2="2";	

	if(!pApp->m_structPortSettingsDlg[m_nPortNo].nDataBits)	//if data bits selected is 5
	{
		m_comboStopBit.ResetContent();	
		m_comboStopBit.InsertString(0,str1);
		m_comboStopBit.InsertString(1,str15);

	}
	else//if number of databits are other than 5
	{
		m_comboStopBit.ResetContent();	
		m_comboStopBit.InsertString(0,str1);
		m_comboStopBit.InsertString(1,str2);
	}

	//initialize all the controls
	
	m_comboBaud.SetCurSel(pApp->m_structPortSettingsDlg[m_nPortNo].nBaud);
	m_comboDataLength.SetCurSel(pApp->m_structPortSettingsDlg[m_nPortNo].nDataBits);
	m_comboParity.SetCurSel(pApp->m_structPortSettingsDlg[m_nPortNo].nParity);
	m_comboStopBit.SetCurSel(pApp->m_structPortSettingsDlg[m_nPortNo].nStopBits);
	m_comboFlowCtrl.SetCurSel(pApp->m_structPortSettingsDlg[m_nPortNo].nFlowCtrl);
	m_check485.SetCheck(pApp->m_structPortSettingsDlg[m_nPortNo].nRS485);
	m_checkIR.SetCheck(pApp->m_structPortSettingsDlg[m_nPortNo].nIR);
	m_checkDTR.SetCheck(pApp->m_structPortSettingsDlg[m_nPortNo].nDTR);
	m_checkRTS.SetCheck(pApp->m_structPortSettingsDlg[m_nPortNo].nRTS);
	m_checkTxFifo.SetCheck(pApp->m_structPortSettingsDlg[m_nPortNo].nTxFIFO);
	m_checkRxFifo.SetCheck(pApp->m_structPortSettingsDlg[m_nPortNo].nRxFIFO);
	m_checkPortOpen.SetCheck(pApp->m_structPortSettingsDlg[m_nPortNo].nPortOpen);
	m_comboComBase.SetCurSel(pApp->m_structPortSettingsDlg[m_nPortNo].nComBase);
	m_comboDTRHys.SetCurSel(pApp->m_structPortSettingsDlg[m_nPortNo].nDTRHys);
	m_comboRTSHys.SetCurSel(pApp->m_structPortSettingsDlg[m_nPortNo].nRTSHys);
	m_comboRxTrig.SetCurSel(pApp->m_structPortSettingsDlg[m_nPortNo].nRxTrig);
	m_comboTxTrig.SetCurSel(pApp->m_structPortSettingsDlg[m_nPortNo].nTxTrig);

#if 0
	if((m_nPortNo==6) || (m_nPortNo==7))
		m_check485.EnableWindow(TRUE);
	else
		m_check485.EnableWindow(FALSE);
#endif

 	m_check485.EnableWindow(TRUE);
	m_checkIR.EnableWindow(TRUE);

	if(m_nPortNo)//Combase selection enabled only for the first port
		m_comboComBase.EnableWindow(FALSE);
	else
		m_comboComBase.EnableWindow(TRUE);

	if(m_checkDTR.GetCheck())
	{
		m_comboDTRHys.EnableWindow(TRUE);
		m_comboRTSHys.EnableWindow(FALSE);
	}
	
	if(m_checkRTS.GetCheck())
	{
		m_comboRTSHys.EnableWindow(TRUE);
		m_comboDTRHys.EnableWindow(FALSE);
	}
	
	if(m_checkTxFifo.GetCheck())
		m_comboTxTrig.EnableWindow(TRUE);
	else
		m_comboTxTrig.EnableWindow(FALSE);

	if(m_checkRxFifo.GetCheck())
		m_comboRxTrig.EnableWindow(TRUE);
	else
		m_comboRxTrig.EnableWindow(FALSE);

	if(m_checkIR.GetCheck())
		m_check485.SetCheck(FALSE); 
	if(m_check485.GetCheck())
		m_checkIR.SetCheck(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPortPage::OnOK() 
{
	//restore the new values into the application variables for the later use
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	pApp->m_structPortSettingsDlg[m_nPortNo].nBaud=m_comboBaud.GetCurSel();
	pApp->m_structPortSettingsDlg[m_nPortNo].nDataBits=m_comboDataLength.GetCurSel();
	pApp->m_structPortSettingsDlg[m_nPortNo].nParity=m_comboParity.GetCurSel();
	pApp->m_structPortSettingsDlg[m_nPortNo].nStopBits=m_comboStopBit.GetCurSel();
	pApp->m_structPortSettingsDlg[m_nPortNo].nFlowCtrl=m_comboFlowCtrl.GetCurSel();
	pApp->m_structPortSettingsDlg[m_nPortNo].nRS485=m_check485.GetCheck();
	pApp->m_structPortSettingsDlg[m_nPortNo].nIR=m_checkIR.GetCheck();
	pApp->m_structPortSettingsDlg[m_nPortNo].nDTR=m_checkDTR.GetCheck();
	pApp->m_structPortSettingsDlg[m_nPortNo].nRTS=m_checkRTS.GetCheck();
	pApp->m_structPortSettingsDlg[m_nPortNo].nPortOpen=m_checkPortOpen.GetCheck();
	pApp->m_structPortSettingsDlg[m_nPortNo].nTxFIFO=m_checkTxFifo.GetCheck();
	pApp->m_structPortSettingsDlg[m_nPortNo].nRxFIFO=m_checkRxFifo.GetCheck();
	if(m_nPortNo==0)
		pApp->m_structPortSettingsDlg[m_nPortNo].nComBase=m_comboComBase.GetCurSel();
	pApp->m_structPortSettingsDlg[m_nPortNo].nDTRHys=m_comboDTRHys.GetCurSel();
	pApp->m_structPortSettingsDlg[m_nPortNo].nRTSHys=m_comboRTSHys.GetCurSel();
	pApp->m_structPortSettingsDlg[m_nPortNo].nRxTrig=m_comboRxTrig.GetCurSel();
	pApp->m_structPortSettingsDlg[m_nPortNo].nTxTrig=m_comboTxTrig.GetCurSel();
	
	
	CPropertyPage::OnOK();
}


void CPortPage::OnSelchangeCombase() 
{
	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	for(int n=1;n<8;n++)
		pApp->m_structPortSettingsDlg[n].nComBase=m_comboComBase.GetCurSel()+n;
}

void CPortPage::OnDTREnabled() 
{
	m_comboDTRHys.EnableWindow(TRUE);
	m_comboRTSHys.EnableWindow(FALSE);	
}

void CPortPage::OnRTSEnabled() 
{
	m_comboRTSHys.EnableWindow(TRUE);
	m_comboDTRHys.EnableWindow(FALSE);	
}

void CPortPage::OnRxFifoEnabled() 
{
	if(m_checkRxFifo.GetCheck())
		m_comboRxTrig.EnableWindow(TRUE);
	else
		m_comboRxTrig.EnableWindow(FALSE);
	
}

void CPortPage::OnTxFifoEnabled() 
{
	if(m_checkTxFifo.GetCheck())
		m_comboTxTrig.EnableWindow(TRUE);
	else
		m_comboTxTrig.EnableWindow(FALSE);
	
}

void CPortPage::OnDropdownStopbit() 
{
	//add the items into the combobox after checking the number of databits selected
	CString str1="1";
	CString str15="1.5";
	CString str2="2";

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();
	
	int databits=pApp->m_structPortSettingsDlg[m_nPortNo].nDataBits=m_comboDataLength.GetCurSel();
	if(!databits)	
	{
		m_comboStopBit.ResetContent();		
		m_comboStopBit.InsertString(0,str1);
		m_comboStopBit.InsertString(1,str15);
		m_comboStopBit.SetCurSel(pApp->m_structPortSettingsDlg[m_nPortNo].nStopBits);//default setting at the begining of the dropdown of the combo box

	}
	else
	{
		m_comboStopBit.ResetContent();	
		m_comboStopBit.InsertString(0,str1);
		m_comboStopBit.InsertString(1,str2);
		m_comboStopBit.SetCurSel(pApp->m_structPortSettingsDlg[m_nPortNo].nStopBits);//default setting at the begining of the dropdown of the combo box
	}
}

void CPortPage::OnSelchangeDatalen() 
{
	CString str1="1";
	CString str15="1.5";
	CString str2="2";

	CSerial758UIApp* pApp=(CSerial758UIApp*)AfxGetApp();

	int databits=pApp->m_structPortSettingsDlg[m_nPortNo].nDataBits=m_comboDataLength.GetCurSel();

	if(databits==5)
	{
		m_comboStopBit.ResetContent();		
		m_comboStopBit.InsertString(0,str1);
		m_comboStopBit.InsertString(1,str15);
		m_comboStopBit.SetCurSel(0);//default setting at the begining of the dropdown of the combo box

	}
	else
	{
		m_comboStopBit.ResetContent();	
		m_comboStopBit.InsertString(0,str1);
		m_comboStopBit.InsertString(1,str2);
		m_comboStopBit.SetCurSel(0);//default setting at the begining of the dropdown of the combo box
	}
}

void CPortPage::OnCrs485() 
{
	// TODO: Add your control notification handler code here
	if(m_check485.GetCheck())
		m_checkIR.SetCheck(FALSE);
}

void CPortPage::OnIr() 
{
	// TODO: Add your control notification handler code here
	if(m_checkIR.GetCheck())
		m_check485.SetCheck(FALSE);
}
