////////////////////////////////////////
//(c) 1999, 2000 EXAR Corporation 
//All Rights Reserved.
//
//Exar Corporation ("Exar") hereby grants the User of this Exar 
//product-specific XR17C158 Windows NT Device Driver (hereinafter 
//referred to as "Driver") a non-exclusive, nontransferable license 
//to use the Driver in accordance with the term set forth below.  
//Before using the Driver, the User should read the following use 
//restrictions.  If the User does not accept these terms, the Driver 
//should not be used or downloaded.
//The User is granted this limited license to use this Driver for 
//User's end product that includes the Exar XR17C158 Octal UART device, 
//and is not granted rights to sell, loan, rent, lease or license the 
//Driver, in whole or in part, or in modified form to anyone other 
//than User.  User may modify the Driver to suit its specific 
//applications but rights to derivative works and such modifications 
//shall belong to Exar.
//
//The Driver is provided on an "AS IS" basis and Exar makes absolutely 
//no warranty with respect to performance or the information contained 
//therein.  EXAR DISCLAIMS AND USER WAIVES ALL WARRANTIES, EXPRESS OR 
//IMPLIED, INCLUDING WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A 
//PARTICULAR PURPOSE.  The entire risk as to Driver quality and 
//performance is with the User.  ACCORDINGLY, IN NO EVENT SHALL EXAR 
//BE LIABLE FOR ANY DAMAGES, WHETHER IN CONTRACT OR TORT, INCLUDING 
//ANY LOST PROFITS OR OTHER INCIDENTAL, CONSEQUENTIAL, EXEMPLARY, OR 
//PUNITIVE DAMAGES ARISING OUT OF THE USE OR APPLICATION OF THE DRIVER.  
//Further, Exar reserves the right to make changes tot eh Driver without 
//notice to improve reliability, function or design.  Exar does not 
//convey any license under patent rights or any other intellectual 
//property rights, including those of third parties.
//
//Exar is not obligated to provide maintenance or support for the Driver. 
//
//Author:	Kevin Guo
//
// e2promDoc.h : interface of the CE2promDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_E2PROMDOC_H__956A7D9D_3035_11D4_987D_00600810AF52__INCLUDED_)
#define AFX_E2PROMDOC_H__956A7D9D_3035_11D4_987D_00600810AF52__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "pciconfig.h"
#include "hardware.h"

#define MAX_SIZE	64//128

class CE2promDoc : public CDocument
{
protected: // create from serialization only
	CE2promDoc();
	DECLARE_DYNCREATE(CE2promDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CE2promDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CE2promDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CE2promDoc)
	afx_msg void OnWrite();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	BOOL		bWrite;
	BOOL		bRead;
	DWORD		dwData;
	DWORD		dwIndex;
	DWORD		dwAddrOffset[MAX_SIZE];
	DWORD		dwDataRead[MAX_SIZE];
	DWORD		dwDataWrite[MAX_SIZE];
	CString		strDataRead[MAX_SIZE];
	CString		strDataWrite[MAX_SIZE];

	CPciConfig *		m_pPCIConfig;
	CHardWare *			m_pHw;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_E2PROMDOC_H__956A7D9D_3035_11D4_987D_00600810AF52__INCLUDED_)
